********************************************************************************
*                                                                              *
*                             DB_BROWS.PRG                                     *
*                                                                              *
*  Copyright (C) 1992 Skelton Software, Kendal Cottage, Hillam, Leeds, UK.     *
*                                                                              *
*                   SEVERELY MODIFIED BY JIM SANDERS 10/93                     *
*                                                                              *
* THIS IS A DATABASE BROWSE THAT IS MODIFIED TO ALLOW CORRECT BEHAVIOR OF THE  *
* SCROLL BARS AND SOME NEAT TRICKS WERE INSERTED TO ALLOW BROWSE TO BE CLOSED  *
* BY RIGHT MOUSE BUTTON OR DOUBLE CLICKS OF LEFT BUTTON (UNLESS ON A MEMO      *
*                                                FIELD WHICH WILL BE SHOWN)    *
* PRESSING F1 TO F3 DOES OTHER NEATO STUFF LIKE ON THE FLY INDEX CHANGES!!!!!! *
*                                                                              *
* QUITE A BIT OF WORK WENT INTO THIS SO YOU LUCKED OUT CAUSE I WILL NOT CHARGE *
* ANY ONE FOR THIS CODE AS LONG AS NO ONE TRYS TO HOLD ME RESPONSIBLE FOR ANY  *
* LOSS OF DATA DUE TO USE OF THESE BROWSE ROUTINES!!!!!!!!!!!!!!               *
*                                                                              *
********************************************************************************

#INCLUDE "DBSTRUCT.CH"
#INCLUDE "DIRECTRY.CH"
#INCLUDE "ERROR.CH"
#INCLUDE "GETEXIT.CH"
#INCLUDE "INKEY.CH"
#INCLUDE "FONT.CH"
#INCLUDE "SETCARET.CH"

* ACCESS DEFINES TO MAKE IFDEF DEFINES VISIBLE
#DEFINE WIN_WANT_LBS        // TO MAKE LISTBOX STYLES ACCESSIBLE
#DEFINE WIN_WANT_CLIPBOARD  // TO MAKE CLIPBOARD DIRECTIVES ACCESSIBLE
#DEFINE WIN_WANT_ALL
#DEFINE WIN_WANT_SYSTEM_METRICS

* NOW CALL INCLUDE WIN.CH SO IFDEF DIRECTIVES ARE ACCESSIBLE
#INCLUDE "WINDOWS.CH"       // WINDOWS.CH MUST BE AFTER WIN_WANT_LBS

EXTERNAL DESCEND  // FOR INDEX FILES THAT MIGHT NEED IT

* NECESSARY IN THE EVENT OF PUSHBUTTON MOVEMENT ON DATA ENTRY SCREEN
* (SEE WREADER.PRG FOR COMPLETE STRUCTURE OF GET:CARGO ARRAY)
* EDIT DEFINES
#DEFINE MAKELPARAM(NLOW, NHIGH)         ((NLOW) + (NHIGH) * 65536)
#DEFINE ID_EDIT 1                       // UNIQUE ID (USED FOR THE EDIT CONTROL)

* TBROWSE DEFINES
#DEFINE B_FIELDNAMES   1
#DEFINE B_RECNO        2
#DEFINE B_ALIAS        3
#DEFINE B_CARGO_LEN    3

* BUTTON DEFINES
#DEFINE BUTTON_HEIGHT  30

* TOTAL NUMBER OF VIEW SCREEN BUTTONS
#DEFINE TOTAL_BUTTONS 13

* 2 BUTTONS USED IN EDIT/ADD SCREENS
#DEFINE B_SAVE   101
#DEFINE B_CANCEL 102

* CLIP4WIN GENERAL DEFINES
#DEFINE FORCE_FOCUS 6
#DEFINE CR          CHR(13)
#DEFINE CR2         CHR(13) + CHR(13)
#DEFINE CRLF        CHR(13) + CHR(10)

* MANIFEST CONSTANTS FOR GETCLIENTRECT() AND GETDIBRECT() ARRAYS
#DEFINE W_LEFT   1
#DEFINE W_TOP    2
#DEFINE W_RIGHT  3
#DEFINE W_BOTTOM 4

* MANIFEST CONSTANTS FOR RGB() COLOR COMBINATIONS
#DEFINE C_RED     RGB(255,0,0)
#DEFINE C_BLUE    RGB(0,0,255)
#DEFINE C_GREEN   RGB(0,255,0)
#DEFINE C_MAGENTA RGB(255,0,255)
#DEFINE C_BLACK   RGB(0,0,0)

#DEFINE APP_NAME  "SCO MANAGEMENT SYSTEM"

#DEFINE ZERO 0 // NEEDED TO ALLOW CALCULATED FIELDS TO BE REDWAWN & NOT MODIFIED

SET SCOREBOARD OFF   // DON'T EVEN THINK ABOUT USING IT IN WINDOWS!!
SET EXACT      ON    // ALLOW SINGLE EQUAL SIGN TO EQUAL DOUBLE EQUAL SIGN
SET ESCAPE     ON    // ALLOW GETS TO BE EXITED WITH ESCAPE
SET DELETED    ON    // GOTTA HAVE DELETED ON
SET CONFIRM    ON    // DO NOT LET OPERATOR LEAVE A FIELD TILL THEY HIT ENTER
SET SOFTSEEK   ON    // ALL SEEKS CAN BE SOFT
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
FUNCTION DOBROWSE(HPWND,CFILE,LSEECOLUMN)
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
*
* PARAMETER 1 AND 2 ARE REQUIRED
*
* IF LSEECOLUMN IS TRUE THEN BROWSE MOVES TO KEY FIELD COLUMN!!!!!!!!!!!!!!!!!
*
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
LOCAL B
LOCAL HWND
LOCAL F
LOCAL NHAND
LOCAL C
LOCAL E
LOCAL X
LOCAL NFIELDS
LOCAL CNTXFILE
LOCAL BOLDHANDLER
LOCAL FIELDS_
LOCAL KEYTEXT
LOCAL FIRSTPLUS
LOCAL LCV
LOCAL RETURNFLD
PUBLIC NVPOS
PUBLIC NHPOS
NHPOS := 1
NVPOS := 0
SELECT &CFILE
HWND = WINNEW("BROWSING " + CFILE + " (F1 FOR NEW SORT)",       ;
                              0, 400, 795, 200, WS_OVERLAPPED  +;
                                                WS_VISIBLE     +;
                                                WS_CAPTION     +;
                                                WS_SYSMENU     +;
                                                WS_MAXIMIZEBOX +;
                                                WS_VSCROLL     +;
                                                WS_HSCROLL     +;
                                                WS_THICKFRAME,  ;
                                                HPWND)
B := TBROWSEDB(0, 0, MAXROW(), MAXCOL())
B:HEADSEP := ""
B:COLSEP  := "  "
B:COLORSPEC := "N/W, W+/R, N/GR+, W+/R"
NFIELDS := FCOUNT()
B:CARGO := ARRAY(B_CARGO_LEN)
* WE ARE GOING TO STORE AN ARRAY OF FIELDNAMES IN THE TBROWSE
* CARGO INSTANCE VARIABLE (TO BE USED WHEN INSERTING NEW COLUMNS)
B:CARGO[B_FIELDNAMES] := ARRAY(NFIELDS)
B:CARGO[B_RECNO] := RECNO()     // RECORD POINTER FOR THIS BROWSE WINDOW
B:CARGO[B_ALIAS] := ALIAS()     // NEEDED WHEN EDITING SPECIFIC CELLS
FIELDS_ := DBSTRUCT()
FOR X := 1 TO NFIELDS
   B:CARGO[B_FIELDNAMES][X] := FIELD(X)
   * MEMOS MUST BE TREATED DIFFERENTLY THAN "REGULAR" FIELDS
   IF FIELDS_[X][DBS_TYPE] = "M"
      C := TBCOLUMNNEW(SUBS(B:CARGO[B_FIELDNAMES][X],2), &("{ || IF(EMPTY(" + ;
                       B:CARGO[B_FIELDNAMES][X] + "), '<MEMO>', '<MEMO>') }"))
      C:CARGO := {}
   ELSE
      C := TBCOLUMNNEW(IF( B:CARGO[B_FIELDNAMES][X]="USERCODE","USERCODE",SUBS(B:CARGO[B_FIELDNAMES][X],2) ), FIELDWBLOCK(B:CARGO[B_FIELDNAMES][X], SELECT()))
   END
   * SET COLOR BLOCK TO HIGHLIGHT NEGATIVE NUMBERS
   IF VALTYPE(EVAL(C:BLOCK)) = "N"
      C:COLORBLOCK := { | X | IF( X < 0, { 3, 4 }, { 1, 2 } ) }
   END
   B:ADDCOLUMN(C)
NEXT
* SET RANGE OF HORIZONTAL SCROLLBAR TO MATCH # OF COLUMNS
* NOTE THAT IF YOU LATER DECIDE TO ADD OR DELETE COLUMNS,
* YOU SHOULD DO THIS AGAIN TO SET THE NEW RANGE
SETSCROLLRANGE(HWND, SB_HORZ, 1, B:COLCOUNT, .F.)
SETSCROLLRANGE(HWND, SB_VERT, 1, LASTREC() , .F.)
* IF LSEECOLUMN NOT NIL THEN MOVE CURSOR TO COLUMN OF FIRST FIELD IN KEY
IF !EMPTY(LSEECOLUMN)
   * DETERMINE 1ST FIELD IN KEY
   KEYTEXT = INDEXKEY(0)
   * WEED OUT DTOS,DESCEND,STR,SUBS,SUBST,SUBSTR AND ()'S
   KEYTEXT = STRTRAN(KEYTEXT,"DTOS")
   KEYTEXT = STRTRAN(KEYTEXT,"DESCEND")
   KEYTEXT = STRTRAN(KEYTEXT,"SUBSTR")
   KEYTEXT = STRTRAN(KEYTEXT,"SUBST")
   KEYTEXT = STRTRAN(KEYTEXT,"SUBS")
   KEYTEXT = STRTRAN(KEYTEXT,"STR")
   KEYTEXT = STRTRAN(KEYTEXT,"(")
   KEYTEXT = STRTRAN(KEYTEXT,")")
   * WHERE DOES FIRST "+" EXIST (IF AT ALL)
   FIRSTPLUS = AT("+",KEYTEXT)
   * GET NAME OF KEY FIELD 1 IF COMPLEX KEY
   IF FIRSTPLUS > 0
      KEYTEXT = SUBS( KEYTEXT, 1, (FIRSTPLUS - 1) )
   END
   * IF KEY FIELD = FIELD 1 THEN LEAVE CURSOR ALONE
   IF FIELD(1) != KEYTEXT
      FOR LCV = 2 TO (FCOUNT() - 1)
         * MOVE CURSOR RIGHT 1 FIELD TILL GET TO KEY FIELD
         B:RIGHT()
         IF KEYTEXT = FIELD(LCV)
            RETURNFLD = LCV
            EXIT
         END
      NEXT
   END
END
NHAND = ADDHANDLER(HWND,{|NEVENT| BROWSEEVENT(NEVENT,HWND,B,NHAND,FIELDS_,HPWND,CFILE)})
UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
RETURN NIL

*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
FUNCTION BROWSEEVENT(NEVENT,HWND,B,NHAND,FIELDS_,HPWND,CFILE)
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
* IF RETURNFLD NOT NIL THEN STUFF VALUE OF RETURNFLD IN GET OBJECT W/ O:VARPUT()
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
LOCAL TEXT := {}
LOCAL MAXELE
LOCAL KEYSTRING
LOCAL NKEY
LOCAL NCOLUMN
LOCAL NWIDTH
LOCAL NTEMPROW
LOCAL NTOPCLEAR
LOCAL NBOTTOMCLEAR
LOCAL X
LOCAL XDIFF
LOCAL HCURSOR
LOCAL HOLDCURSOR
LOCAL NSCROLLCMD
LOCAL NNEWREC
LOCAL NOLDREC
LOCAL NSKIPCNT
LOCAL OCOLUMN
LOCAL RETURNVAL
LOCAL LCV
LOCAL OLDWND := SELECTWINDOW(HWND)
* NOTE: THESE STATICS SHOULD EVENTUALLY BE ENCAPSULATED WITHIN
*       THE APPROPRIATE TBROWSE OBJECT
STATIC LKEYPRESSED := .F.
IF ALIAS() != CFILE
   SELECT &CFILE
END
DO CASE
CASE NEVENT = EVENT_HSCROLL
   NSCROLLCMD = _LASTWPARAM()      // FROM WINDOWS
   DO CASE
   CASE NSCROLLCMD = SB_LEFT
      IF B:COLPOS > 1
         B:PANHOME()
         B:FORCESTABLE()
         NHPOS = 1
         SETSCROLLPOS(HWND, SB_HORZ, NHPOS, .T.)
      END
   CASE NSCROLLCMD = SB_RIGHT
      IF B:COLPOS < B:COLCOUNT
         B:PANEND()
         B:FORCESTABLE()
         NHPOS = B:COLCOUNT
         SETSCROLLPOS(HWND, SB_HORZ, NHPOS, .T.)
      END
   CASE NSCROLLCMD = SB_LINELEFT
      IF B:COLPOS > 1
         B:LEFT()
         B:FORCESTABLE()
         NHPOS = B:COLPOS
         SETSCROLLPOS(HWND, SB_HORZ, NHPOS, .T.)
      END
   CASE NSCROLLCMD = SB_LINERIGHT
      IF B:COLPOS < B:COLCOUNT
         B:RIGHT()
         B:FORCESTABLE()
         NHPOS = B:COLPOS
         SETSCROLLPOS(HWND, SB_HORZ, NHPOS, .T.)
      END
   CASE NSCROLLCMD = SB_PAGELEFT
      IF B:COLPOS > 1
         B:PANLEFT()
         B:FORCESTABLE()
         NHPOS = B:COLPOS
         SETSCROLLPOS(HWND, SB_HORZ, NHPOS, .T.)
      END
   CASE NSCROLLCMD = SB_PAGERIGHT
      IF B:COLPOS < B:COLCOUNT
         B:PANRIGHT()
         B:FORCESTABLE()
         NHPOS = B:COLPOS
         SETSCROLLPOS(HWND, SB_HORZ, NHPOS, .T.)
      END
   CASE NSCROLLCMD = SB_THUMBPOSITION .OR. NSCROLLCMD = SB_THUMBTRACK
      // IGNORE
      X = INT(_LASTLOLPARAM())     // FROM WINDOWS
      DO CASE
      CASE X > B:COLPOS
         XDIFF = X - B:COLPOS
         FOR LCV = 1 TO XDIFF
            B:RIGHT()
            IF B:COLPOS = B:COLCOUNT
               EXIT
            END
         NEXT
         B:FORCESTABLE()
         NHPOS = X
         SETSCROLLPOS(HWND, SB_HORZ, NHPOS, .T.)
      CASE X < B:COLPOS
         XDIFF = B:COLPOS - X
         FOR LCV = 1 TO XDIFF
            B:LEFT()
            IF B:COLPOS = 1
               EXIT
            END
         NEXT
         B:FORCESTABLE()
         NHPOS = X
         SETSCROLLPOS(HWND, SB_HORZ, NHPOS, .T.)
      END
   END
CASE NEVENT = EVENT_VSCROLL
   NSCROLLCMD = _LASTWPARAM()
   DO CASE
   CASE NSCROLLCMD = SB_TOP
      B:GOTOP()
      B:FORCESTABLE()
      NVPOS = 0
      SETSCROLLPOS(HWND, SB_VERT, MIN(NVPOS,LASTREC()), .T.)
   CASE NSCROLLCMD = SB_BOTTOM
      B:GOBOTTOM()
      B:FORCESTABLE()
      NVPOS = LASTREC()
      SETSCROLLPOS(HWND, SB_VERT, MIN(NVPOS,LASTREC()), .T.)
   CASE NSCROLLCMD = SB_LINEDOWN
      B:DOWN()
      B:FORCESTABLE()
      IF EMPTY(INDEXKEY(0))
         NVPOS = RECNO()
      ELSE
         NVPOS = NTXPOS(INDEXORD(),RECNO())
      END
      SETSCROLLPOS(HWND, SB_VERT, MIN(NVPOS,LASTREC()), .T.)
   CASE NSCROLLCMD = SB_PAGEDOWN
      B:PAGEDOWN()
      B:FORCESTABLE()
      IF EMPTY(INDEXKEY(0))
         NVPOS = RECNO()
      ELSE
         NVPOS = NTXPOS(INDEXORD(),RECNO())
      END
      SETSCROLLPOS(HWND, SB_VERT, MIN(NVPOS,LASTREC()), .T.)
   CASE NSCROLLCMD = SB_LINEUP
      B:UP()
      B:FORCESTABLE()
      IF EMPTY(INDEXKEY(0))
         NVPOS = RECNO()
      ELSE
         NVPOS = NTXPOS(INDEXORD(),RECNO())
      END
      SETSCROLLPOS(HWND, SB_VERT, MIN(NVPOS,LASTREC()), .T.)
   CASE NSCROLLCMD = SB_PAGEUP
      B:PAGEUP()
      B:FORCESTABLE()
      IF EMPTY(INDEXKEY(0))
         NVPOS = RECNO()
      ELSE
         NVPOS = NTXPOS(INDEXORD(),RECNO())
      END
      SETSCROLLPOS(HWND, SB_VERT, MIN(NVPOS,LASTREC()), .T.)
   CASE NSCROLLCMD = SB_THUMBPOSITION .OR. NSCROLLCMD = SB_THUMBTRACK
      X = INT(_LASTLOLPARAM())     // FROM WINDOWS
      DO CASE
      CASE X < NVPOS
         XDIFF = NVPOS - X
         FOR LCV = 1 TO XDIFF
            B:UP()
         NEXT
         NVPOS = X
         B:FORCESTABLE()
         SETSCROLLPOS(HWND, SB_VERT, MIN(NVPOS,LASTREC()), .T.)
      CASE X > NVPOS
         XDIFF = X - NVPOS
         FOR LCV = 1 TO XDIFF
            B:DOWN()
         NEXT
         NVPOS = X
         B:FORCESTABLE()
         SETSCROLLPOS(HWND, SB_VERT, MIN(NVPOS,LASTREC()), .T.)
      END
   END
CASE NEVENT = EVENT_RCLICK
   ENABLEWINDOW(HPWND,.T.)
   BRINGWINDOWTOTOP(HPWND)
   SELECTWINDOW(HPWND)
   INVALIDATERECT(HPWND)
   RETURN NIL
CASE NEVENT = EVENT_KILLFOCUS
   B:CARGO[B_RECNO] := RECNO()
CASE NEVENT = EVENT_REDRAW
   IF ! LKEYPRESSED
      SETCURSOR(HWAIT)
      B:REFRESHALL()
   ELSE
      LKEYPRESSED := .F.
      SETCURSOR(HWAIT)
      B:REFRESHALL()
   END
   B:FORCESTABLE()
   SETCURSOR(HAROW)   // RESTORE PREVIOUS CURSOR
   HIDECARET(HWND)
   UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
CASE NEVENT = EVENT_KEY
   NKEY := INKEY(0)
   LKEYPRESSED := .T.
   DO CASE
   CASE NKEY = K_F1
      IF PICKASORT(CFILE,HWND) != IDCANCEL
         INVALIDATERECT(HWND)
      END
   CASE NKEY = K_F2
      IF EMPTY(INDEXKEY())
         KEYSTRING = "NATURAL ORDER OF ADDITION TO FILE"
      ELSE
         KEYSTRING = INDEXKEY()
         * TAKE OUT DESCEND,DTOS,SUBSTR,STR,() STRINGS
         KEYSTRING = STRTRAN(KEYSTRING,"DESCEND")
         KEYSTRING = STRTRAN(KEYSTRING,"DTOS")
         KEYSTRING = STRTRAN(KEYSTRING,"SUBSTR")
         KEYSTRING = STRTRAN(KEYSTRING,"SUBST")
         KEYSTRING = STRTRAN(KEYSTRING,"SUBS")
         KEYSTRING = STRTRAN(KEYSTRING,"STR")
         KEYSTRING = STRTRAN(KEYSTRING,"(")
         KEYSTRING = STRTRAN(KEYSTRING,")")
         KEYSTRING = STRTRAN(KEYSTRING,"+"," + ")
         * TAKE 1ST LETTER OF EACH FIELD OFF IF NOT = USERCODE
         TEXT = {}
         LCV = 0
         WHILE .T.
            LCV++
            AADD(TEXT,PARSE(@KEYSTRING))
            IF EMPTY(TEXT[LCV])
               MAXELE = (LCV - 1)
               EXIT
            END
         END
         FOR LCV = 1 TO MAXELE
            * DO NOTHING TO PLUS SIGNS & EXTRACT 1ST LETTER IF NOT USERCODE
            IF TEXT[LCV] != "USERCODE" .AND. TEXT[LCV] != "+"
               TEXT[LCV] = SUBS(TEXT[LCV],2)
            END
         NEXT
         * CAT ALL ELE'S BACK TOGETHER
         KEYSTRING = ""
         FOR LCV = 1 TO MAXELE
            KEYSTRING += TEXT[LCV] + SPAC(1)
         NEXT
         * TRIM TRAILING BLANK
         KEYSTRING = TRIM(KEYSTRING)
      END
      SAYMSG("SORT = " + KEYSTRING)
   CASE NKEY = K_F3
      SAYMSG("FILTER = " + DBFILTER() )
   CASE NKEY = K_ESC
      ENABLEWINDOW(HPWND,.T.)
      BRINGWINDOWTOTOP(HPWND)
      SELECTWINDOW(HPWND)
      INVALIDATERECT(HPWND)
      RETURN NIL
   CASE NKEY = K_CTRL_LEFT
      B:PANLEFT()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_CTRL_RIGHT
      B:PANRIGHT()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_HOME
      B:HOME()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_END
      B:END()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_CTRL_HOME
      B:PANHOME()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_CTRL_END
      B:PANEND()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_UP
      B:UP()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_DOWN
      B:DOWN()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_PGUP
      B:PAGEUP()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_PGDN
      B:PAGEDOWN()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_CTRL_PGUP
      B:GOTOP()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_CTRL_PGDN
      B:GOBOTTOM()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_LEFT
      B:LEFT()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_RIGHT
      B:RIGHT()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_ENTER
      ENABLEWINDOW(HPWND,.T.)
      BRINGWINDOWTOTOP(HPWND)
      SELECTWINDOW(HPWND)
      INVALIDATERECT(HPWND)
      RETURN NIL
   CASE CHR(NKEY) = "+"            // EXPAND CURRENT COLUMN
      OCOLUMN := B:GETCOLUMN(B:COLPOS)
      IF OCOLUMN:WIDTH = NIL
         OCOLUMN:WIDTH := B:COLWIDTH(B:COLPOS)
      END
      OCOLUMN:WIDTH++
      B:CONFIGURE()
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE CHR(NKEY) = "-"            // SHRINK CURRENT COLUMN
      OCOLUMN := B:GETCOLUMN(B:COLPOS)
      IF OCOLUMN:WIDTH = NIL
         OCOLUMN:WIDTH := B:COLWIDTH(B:COLPOS)
      END
      IF OCOLUMN:WIDTH > 1
         OCOLUMN:WIDTH--
         B:CONFIGURE()
      END
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_INS               // INSERT NEW COLUMN
      IF ! EMPTY(X := PICKFIELD(B))
         B:INSCOLUMN(B:COLPOS, TBCOLUMNNEW(X, FIELDBLOCK(X)))
         SETSCROLLRANGE(HWND, SB_HORZ, 1, B:COLCOUNT, .T.)
      END
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   CASE NKEY = K_DEL               // DELETE CURRENT COLUMN
      B:DELCOLUMN(B:COLPOS)
      SETSCROLLRANGE(HWND, SB_HORZ, 1, B:COLCOUNT, .T.)
      * MOVE CURSOR TO COLUMN AT LEFT OF ONE WE JUST DELETED IF NOT COLUMN 1
      IF B:COLPOS > 1
         B:COLPOS--
      END
      UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
   OTHERWISE
      LKEYPRESSED := .F.
      MESSAGEBEEP(MB_ICONEXCLAMATION)
   END
   IF LKEYPRESSED
      B:FORCESTABLE()
   END
CASE NEVENT = EVENT_WINSIZE
   B:NBOTTOM := MAXROW()
   B:NRIGHT := MAXCOL()
   SETSCROLLRANGE(HWND, SB_HORZ, 1, B:COLCOUNT, .F.)
   SETSCROLLRANGE(HWND, SB_VERT, 1, LASTREC() , .F.)
   UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
CASE NEVENT = EVENT_LDBLCLK     // TREAT LEFT DOUBLE-CLICK AS ENTER
   * SHOW MEMO TEXT IF THEY DOUBLE CLICK ON A MEMO FIELD
   IF FIELDS_[B:COLPOS][DBS_TYPE] = "M"
      SAYMSG(IF(EMPTY(&(FIELDS_[B:COLPOS][DBS_NAME])),"THE MEMO FIELD OF THIS RECORD IS EMPTY!",&(FIELDS_[B:COLPOS][DBS_NAME])),"MEMO FIELD TEXT")
      HIDECARET(HWND)
      B:FORCESTABLE()
   ELSE
      ENABLEWINDOW(HPWND,.T.)
      BRINGWINDOWTOTOP(HPWND)
      SELECTWINDOW(HPWND)
      INVALIDATERECT(HPWND)
      RETURN NIL
   END
CASE NEVENT = EVENT_LCLICK
   * DETERMINE NUMBER OF VISIBLE COLUMNS (WITH SEPARATORS)
   NCOLUMN := B:LEFTVISIBLE - 1
   NWIDTH := 0
   WHILE ++NCOLUMN <= B:RIGHTVISIBLE
      NWIDTH += B:COLWIDTH(NCOLUMN) + 1
   END
   * SINCE THE TBROWSE IS ALWAYS CENTERED, FIND THE LEFT PADDING
   NWIDTH := INT((B:NRIGHT - B:NLEFT + 1 - NWIDTH) / 2)

   * NOW LOCATE COLUMN IN WHICH MOUSE CURSOR SITS
   NCOLUMN := B:LEFTVISIBLE - 1
   WHILE ++NCOLUMN <= B:COLCOUNT .AND. ;
            (NWIDTH += B:COLWIDTH(NCOLUMN) + 1) < MOUSECOL()
   END
   B:REFRESHCURRENT()  // GET RID OF OLD HIGHLIGHT ON PREVIOUS ROW
   B:COLPOS := NCOLUMN
   * THE NEXT LINE IS PURELY TEMPORARY AND WILL HAVE TO BE REVAMPED
   * BECAUSE IT MAKES THE SOMEWHAT DANGEROUS ASSUMPTION THAT THERE
   * WILL ALWAYS BE A TOTAL OF TWO LINES FOR THE COLUMN HEADINGS AND
   * HEADING SEPARATOR
   B:ROWPOS := MOUSEROW() - IF(! EMPTY(B:HEADSEP), 1, 0)
   B:FORCESTABLE()
   UPDATESCROLLBAR(HWND, B, @NVPOS, @NHPOS)
CASE NEVENT = EVENT_CLOSE   .OR.;
     NEVENT = EVENT_DESTROY .OR.;
     NEVENT = EVENT_QUIT
   ENABLEWINDOW(HPWND,.T.)
   BRINGWINDOWTOTOP(HPWND)
   SELECTWINDOW(HPWND)
   INVALIDATERECT(HPWND)
   RETURN NIL
END
SELECTWINDOW(OLDWND)
RETURN NIL

*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
FUNCTION UPDATESCROLLBAR(HWND, B, NVPOS, NHPOS)
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
NHPOS = B:COLPOS
IF EMPTY(INDEXKEY(0))
   NVPOS = RECNO()
ELSE
   NVPOS = NTXPOS(INDEXORD(),RECNO())
END
SETSCROLLPOS(HWND, SB_HORZ, NHPOS               , .T.)
SETSCROLLPOS(HWND, SB_VERT, MIN(NVPOS,LASTREC()), .T.)
RETURN NIL

*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
FUNCTION PICKASORT(CFILE,HPWND)
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
* LET USER SELECT A SORT BEFORE BROWSEING A FILE OR WHILE IN A BROWSE WITH ALT-S
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
LOCAL ADLG
LOCAL THISKEY
LOCAL LCV
LOCAL MAXELE
LOCAL CTEXT   := ""
LOCAL KEYLIST := {}
LOCAL TEXT    := {}
LOCAL LISTLEN := 0
AADD(KEYLIST,NSTR(LISTLEN) + " NATURAL ORDER OF ADDITION TO FILE")
LISTLEN++
* LOAD KEYS INTO KEYLIST[] FROM DATADEF.DBF
SELECT DATADEF
SEEK CFILE
WHILE .T.
   THISKEY = KEY
   * TAKE OUT DESCEND,DTOS,SUBSTR,STR,() STRINGS
   THISKEY = STRTRAN(THISKEY,"DESCEND")
   THISKEY = STRTRAN(THISKEY,"DTOS")
   THISKEY = STRTRAN(THISKEY,"SUBSTR")
   THISKEY = STRTRAN(THISKEY,"SUBST")
   THISKEY = STRTRAN(THISKEY,"SUBS")
   THISKEY = STRTRAN(THISKEY,"STR")
   THISKEY = STRTRAN(THISKEY,"(")
   THISKEY = STRTRAN(THISKEY,")")
   THISKEY = STRTRAN(THISKEY,"+"," + ")
   * TAKE 1ST LETTER OF EACH FIELD OFF IF NOT = USERCODE
   TEXT = {}
   LCV = 0
   WHILE .T.
      LCV++
      AADD(TEXT,PARSE(@THISKEY))
      IF EMPTY(TEXT[LCV])
         MAXELE = (LCV - 1)
         EXIT
      END
   END
   FOR LCV = 1 TO MAXELE
      * DO NOTHING TO PLUS SIGNS & EXTRACT 1ST LETTER IF NOT USERCODE
      IF TEXT[LCV] != "USERCODE" .AND. TEXT[LCV] != "+"
         TEXT[LCV] = SUBS(TEXT[LCV],2)
      END
   NEXT
   * CAT ALL ELE'S BACK TOGETHER
   THISKEY = ""
   FOR LCV = 1 TO MAXELE
      THISKEY += TEXT[LCV] + SPAC(1)
   NEXT
   * TRIM TRAILING BLANK
   THISKEY = TRIM(THISKEY)
   AADD(KEYLIST,NSTR(LISTLEN) + " " + THISKEY)
   SKIP
   IF EOF() .OR. ALLTRIM(DBF) != CFILE
      EXIT
   END
   LISTLEN++
END
SELECT &CFILE
WHILE .T.
   ADLG = CREATEDIALOG("SORT SELECTION",                                        ;
               WS_GROUP + WS_VISIBLE + WS_TABSTOP + WS_DLGFRAME,                ;
               100, 10, 160, 151 )
   ADLG = APPENDDIALOG(ADLG, "GROUP", DLG_BUTTON,                               ;
               BS_GROUPBOX + WS_GROUP + WS_CHILD + WS_VISIBLE,                  ;
               5, 5, 150, 105, "PICK A SORT")
   ADLG = APPENDDIALOG(ADLG, "LISTBOX", DLG_LISTBOX,                            ;
               LBS_NOTIFY + WS_BORDER + WS_CHILD + WS_VISIBLE + WS_TABSTOP,     ;
               10, 15, 140, 90, KEYLIST)
   ADLG = APPENDDIALOG(ADLG, "OK", DLG_BUTTON, BS_DEFPUSHBUTTON + WS_TABSTOP +     ;
               WS_CHILD + WS_VISIBLE,                                           ;
               5, 120, 75, 20, "&OK")
   ADLG = APPENDDIALOG(ADLG, "CANCEL", DLG_BUTTON, BS_PUSHBUTTON + WS_TABSTOP + ;
               WS_CHILD + WS_VISIBLE,                                           ;
               85, 120, 75, 20, "&CANCEL")
   IF MODALDIALOG(ADLG,HINST,SELECTWINDOW()) != 0 .AND. !GETDIALOGRESULT(ADLG,"CANCEL")
      CTEXT = GETDIALOGRESULT(ADLG,"LISTBOX")
      IF !EMPTY(CTEXT)
         * SET ORDER TO INDEX NO. FOUND ON FRONT OF KEYLIST
         NEWORDER(VAL(PARSE(CTEXT)))
      ELSE
         SAYERR("YOU DID NOT PICK A SORT!")
         LOOP
      END
   ELSE
      RETURN IDCANCEL
   END
   EXIT
END
RETURN IDOK

*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
FUNCTION SAYMSG(TEXT,INFO)
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *
MESSAGEBOX( , TEXT, IF(EMPTY(INFO),"INFO",INFO), MB_ICONASTERISK + MB_OK)
RETURN NIL
